local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('stddef')
lj_include('bits_waitflags')
lj_include('bits_waitstatus')

ffi.cdef[[
typedef struct {
    int quot;
    int rem;
} div_t;
typedef struct {
    long int quot;
    long int rem;
} ldiv_t;
typedef struct {
    long long int quot;
    long long int rem;
} lldiv_t;
size_t __ctype_get_mb_cur_max(void);
double atof(const char *__nptr);
int atoi(const char *__nptr);
long int atol(const char *__nptr);
long long int atoll(const char *__nptr);
double strtod(const char *__nptr, char **__endptr);
float strtof(const char *__nptr, char **__endptr);
long double strtold(const char *__nptr, char **__endptr);
long int strtol(const char *__nptr, char **__endptr, int __base);
unsigned long int strtoul(const char *__nptr, char **__endptr, int __base);
long long int strtoq(const char *__nptr, char **__endptr, int __base);
unsigned long long int strtouq(const char *__nptr,
    char **__endptr, int __base);
long long int strtoll(const char *__nptr, char **__endptr, int __base);
unsigned long long int strtoull(const char *__nptr,
    char **__endptr, int __base);
]]

lj_include('xlocale')

ffi.cdef[[
long int strtol_l(const char *__nptr,
    char **__endptr, int __base, __locale_t __loc);
unsigned long int strtoul_l(const char *__nptr,
    char **__endptr, int __base, __locale_t __loc);
long long int strtoll_l(const char *__nptr,
    char **__endptr, int __base, __locale_t __loc);
unsigned long long int strtoull_l(const char *__nptr,
    char **__endptr, int __base, __locale_t __loc);
double strtod_l(const char *__nptr, char **__endptr, __locale_t __loc);
float strtof_l(const char *__nptr, char **__endptr, __locale_t __loc);
long double strtold_l(const char *__nptr,
    char **__endptr, __locale_t __loc);
char *l64a(long int __n);
long int a64l(const char *__s);
]]

lj_include('sys_types')

ffi.cdef[[
long int random(void);
void srandom(unsigned int __seed);
char *initstate(unsigned int __seed, char *__statebuf, size_t __statelen);
char *setstate(char *__statebuf);
struct random_data {
    int32_t *fptr;
    int32_t *rptr;
    int32_t *state;
    int rand_type;
    int rand_deg;
    int rand_sep;
    int32_t *end_ptr;
};
int random_r(struct random_data *__buf, int32_t * __result);
int srandom_r(unsigned int __seed, struct random_data *__buf);
int initstate_r(unsigned int __seed, char *__statebuf,
    size_t __statelen, struct random_data *__buf);
int setstate_r(char *__statebuf, struct random_data *__buf);
int rand(void);
void srand(unsigned int __seed);
int rand_r(unsigned int *__seed);
double drand48(void);
double erand48(unsigned short int __xsubi[3]);
long int lrand48(void);
long int nrand48(unsigned short int __xsubi[3]);
long int mrand48(void);
long int jrand48(unsigned short int __xsubi[3]);
void srand48(long int __seedval);
unsigned short int *seed48(unsigned short int __seed16v[3]);
void lcong48(unsigned short int __param[7]);
struct drand48_data {
    unsigned short int __x[3];
    unsigned short int __old_x[3];
    unsigned short int __c;
    unsigned short int __init;
    unsigned long long int __a;
};
int drand48_r(struct drand48_data *__buffer, double *__result);
int erand48_r(unsigned short int __xsubi[3],
    struct drand48_data *__buffer, double *__result);
int lrand48_r(struct drand48_data *__buffer, long int *__result);
int nrand48_r(unsigned short int __xsubi[3],
    struct drand48_data *__buffer, long int *__result);
int mrand48_r(struct drand48_data *__buffer, long int *__result);
int jrand48_r(unsigned short int __xsubi[3],
    struct drand48_data *__buffer, long int *__result);
int srand48_r(long int __seedval, struct drand48_data *__buffer);
int seed48_r(unsigned short int __seed16v[3],
    struct drand48_data *__buffer);
int lcong48_r(unsigned short int __param[7],
    struct drand48_data *__buffer);
void *malloc(size_t __size);
void *calloc(size_t __nmemb, size_t __size);
void *realloc(void *__ptr, size_t __size);
void free(void *__ptr);
void cfree(void *__ptr);
]]

lj_include('alloca')

ffi.cdef[[
void *valloc(size_t __size);
int posix_memalign(void **__memptr, size_t __alignment, size_t __size);
void abort(void);
int atexit(void (*__func) (void));
int at_quick_exit(void (*__func) (void));
int on_exit(void (*__func) (int __status, void *__arg), void *__arg);
void exit(int __status);
void quick_exit(int __status);
void _Exit(int __status);
char *getenv(const char *__name);
char *__secure_getenv(const char *__name);
int putenv(char *__string);
int setenv(const char *__name, const char *__value, int __replace);
int unsetenv(const char *__name);
int clearenv(void);
char *mktemp(char *__template);
int mkstemp(char *__template);
int mkstemp64(char *__template);
char *mkdtemp(char *__template);
int mkostemp(char *__template, int __flags);
int mkostemp64(char *__template, int __flags);
int system(const char *__command);
char *canonicalize_file_name(const char *__name);
char *realpath(const char *__name, char *__resolved);
typedef int (*__compar_fn_t) (const void *, const void *);
typedef __compar_fn_t comparison_fn_t;
typedef int (*__compar_d_fn_t) (const void *, const void *, void *);
void *bsearch(const void *__key, const void *__base,
    size_t __nmemb, size_t __size, __compar_fn_t __compar);
void qsort(void *__base, size_t __nmemb, size_t __size,
    __compar_fn_t __compar);
void qsort_r(void *__base, size_t __nmemb, size_t __size,
    __compar_d_fn_t __compar, void *__arg);
int abs(int __x);
long int labs(long int __x);
long long int llabs(long long int __x);
div_t div(int __numer, int __denom);
ldiv_t ldiv(long int __numer, long int __denom);
lldiv_t lldiv(long long int __numer, long long int __denom);
char *ecvt(double __value, int __ndigit, int *__decpt, int *__sign);
char *fcvt(double __value, int __ndigit, int *__decpt, int *__sign);
char *gcvt(double __value, int __ndigit, char *__buf);
char *qecvt(long double __value, int __ndigit, int *__decpt, int *__sign);
char *qfcvt(long double __value, int __ndigit, int *__decpt, int *__sign);
char *qgcvt(long double __value, int __ndigit, char *__buf);
int ecvt_r(double __value, int __ndigit, int *__decpt,
    int *__sign, char *__buf, size_t __len);
int fcvt_r(double __value, int __ndigit, int *__decpt,
    int *__sign, char *__buf, size_t __len);
int qecvt_r(long double __value, int __ndigit,
    int *__decpt, int *__sign, char *__buf, size_t __len);
int qfcvt_r(long double __value, int __ndigit,
    int *__decpt, int *__sign, char *__buf, size_t __len);
int mblen(const char *__s, size_t __n);
int mbtowc(wchar_t * __pwc, const char *__s, size_t __n);
int wctomb(char *__s, wchar_t __wchar);
size_t mbstowcs(wchar_t * __pwcs, const char *__s, size_t __n);
size_t wcstombs(char *__s, const wchar_t * __pwcs, size_t __n);
int rpmatch(const char *__response);
int getsubopt(char **__optionp, char *const *__tokens, char **__valuep);
void setkey(const char *__key);
int posix_openpt(int __oflag);
int grantpt(int __fd);
int unlockpt(int __fd);
char *ptsname(int __fd);
int ptsname_r(int __fd, char *__buf, size_t __buflen);
int getpt(void);
int getloadavg(double __loadavg[], int __nelem);
]]

local defs = {
    RAND_MAX = '2147483647',
    EXIT_FAILURE = '1',
    EXIT_SUCCESS = '0',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

