local ffi = require'ptpv2-ffi/cdata'
local C = ffi.C

local m = {}

function m:announce_receipt_timer_handler()
    local ci = self.clock_info

    if ci.state == C.PTP_STATE_LISTENING or
        ci.state == C.PTP_STATE_PASSIVE or
        ci.state == C.PTP_STATE_UNCALIBRATED or
        ci.state == C.PTP_STATE_SLAVE then

        ci.number_foreign_records = 0
        ci.foreign_record_i = 0

        if ci.slave_only == 0 and ci.clock_quality.clock_class ~= 255 then
            self:m1()
            self:to_state(C.PTP_STATE_MASTER)
        elseif ci.state ~= C.PTP_STATE_LISTENING then
            self:to_state(C.PTP_STATE_LISTENING)
        end
    end
end

function m:sync_interval_timer_handler()
    if self.clock_info.state == C.PTP_STATE_MASTER then
        self.send[C.PTP_MSG_TYPE_SYNC](self)
    end
end

function m:announce_interval_timer_handler()
    if self.clock_info.state == C.PTP_STATE_MASTER then
        self.send[C.PTP_MSG_TYPE_ANNOUNCE](self)
    end
end

function m:delay_req_interval_timer_handler()
    local ci = self.clock_info

    if ci.state == C.PTP_STATE_LISTENING or
        ci.state == C.PTP_STATE_PASSIVE or
        ci.state == C.PTP_STATE_UNCALIBRATED or
        ci.state == C.PTP_STATE_SLAVE then
        self.send[C.PTP_MSG_TYPE_DELAY_REQ](self)
    end
end

return m
