(= html_preamble() =)
<html>
<head>
<title>Sign In - Armada</title>
<link type="text/css" href="css/jquery.ui.all.css" rel="stylesheet">
<link type="text/css" href="css/armada.css" rel="stylesheet">
<style type="text/css">

body {
    font-family: Arial, Helvetica, sans-serif;
}

.sign-in {
    width: 100%;
    text-align: center;
}

fieldset {
    font-family: Arial, Helvetica, sans-serif;
    border: 2px solid #CCCCCC;
    -moz-border-radius: 10px;
    -webkit-border-radius: 10px;
    -khtml-border-radius: 10px;
    border-radius: 10px;
    margin-top: .5em;
    margin-bottom: .5em;
    display: inline-block;
    text-align: left;
}

input[type="text"], input[type="password"] {
    border: 1px solid #888888;
    -moz-border-radius: 6px;
    -webkit-border-radius: 6px;
    -khtml-border-radius: 6px;
    border-radius: 6px;
}

label {
    white-space: nowrap;
}

.sign-in label {
    font-size: 85%;
    font-family: Arial, Helvetica, sans-serif;
    margin-top: .4em;
    display: block;
}

.sign-in label > * {
    margin-top: .1em;
    display: block;
    position: relative;
    top: 0em;
    left: 0em;
}

.sign-in input[type="submit"] {
    margin-top: 1em;
}

.language-selector {
    width: 100%;
    text-align: center;
    font-size: 90%;
    color: #0000A0;
}

.language-selector a {
    text-decoration: none;
    color: #6666AA;
    margin-left: 1em;
    margin-right: 1em;
}

.language-selector span {
    color: #000000;
    margin-left: 1em;
    margin-right: 1em;
}

.language-selector a:visited {
    color: #6666AA;
}

.language-selector a:hover {
    color: #0000FF;
}

.error-message {
    color: #FF0000;
}

.error-field {
    background-color: #FFDDDD;
}

</style>

<script type="text/javascript" src="js/jquery.min.js"></script>
<script type="text/javascript" src="js/jquery-ui.min.js"></script>
<script type="text/javascript" src="js/jquery.cookie.js"></script>
<script type="text/javascript" src="js/jquery.url.js"></script>
<script type="text/javascript">
$(function() {
    var request = (= request_json =);
    var translations = {
        "zh-CN": { // Chinese Simplified (zh-TW is Traditional Han)
            "language_name": "简体中文",
            "sign_in_title": "登录 - eDAQ Armada",
            "sign_in_label": "登录",
            "user_name_label": "用户名",
            "password_label": "密码"
        },
        "en-US": { // English
            "language_name": "English",
            "sign_in_title": "Sign In - eDAQ Armada",
            "sign_in_label": "Sign In",
            "user_name_label": "User Name",
            "password_label": "Password"
        },
        "fr": { // French
            "language_name": "français",
            "sign_in_title": "Ouvrir une session - eDAQ Armada",
            "sign_in_label": "Ouvrir une session",
            "user_name_label": "Nom d'utilisateur",
            "password_label": "Mot de passe"
        },
        "de": { // German
            "language_name": "Deutsch",
            "sign_in_title": "Anmelden - eDAQ Armada",
            "sign_in_label": "Anmelden",
            "user_name_label": "Nutzername",
            "password_label": "Passwort"
        },
        "ja": { // Japanese
            "language_name": "日本語",
            "sign_in_title": "ログイン - eDAQ Armada",
            "sign_in_label": "ログイン",
            "user_name_label": "ユーザー名",
            "password_label": "パスワード"
        }
    };
    var message_translations = {
        "zh-CN": { // Chinese Simplified (zh-TW is Traditional Han)
            "Incorrect user name or password": "不正确的用户名或密码",
            "Connection error": "连接错误"
        },
        "en-US": { // English
            "Incorrect user name or password":
                "Incorrect user name or password",
            "Connection error": "Connection error"
        },
        "fr": { // French
            "Incorrect user name or password":
                "Nom d'utilisateur ou mot de passe incorrects",
            "Connection error": "erreur de connexion"
        },
        "de": { // German
            "Incorrect user name or password":
                "Falsche Benutzernamen oder Ihr Passwort",
            "Connection error": "Verbindungsfehler"
        },
        "ja": { // Japanese
            "Incorrect user name or password":
                "間違ったユーザー名またはパスワード",
            "Connection error": "接続エラー"
        }
    };
    var language_name_matrix = {
        "zh-CN": { // Chinese Simplified (zh-TW is Traditional Han)
            "zh-CN": "简体中文",
            "en-US": "英语",
            "fr": "法国",
            "de": "德国",
            "ja": "日本"
        },
        "en-US": { // English
            "zh-CN": "Chinese (Simplified)",
            "en-US": "English",
            "fr": "French",
            "de": "German",
            "ja": "Japanese"
        },
        "fr": { // French
            "zh-CN": "chinois",
            "en-US": "anglais",
            "fr": "français",
            "de": "allemand",
            "ja": "japonais"
        },
        "de": { // German
            "zh-CN": "Chinesisch",
            "en-US": "Englisch",
            "fr": "Französisch",
            "de": "Deutsch",
            "ja": "Japanisch"
        },
        "ja": { // Japanese
            "zh-CN": "中国",
            "en-US": "英語を",
            "fr": "フランス",
            "de": "ドイツ",
            "ja": "日本語"
        }
    };
    var languages = [];
    for (var lang in translations) {
        languages.push(lang);
    }
    languages.sort();

    var current_language;

    function tr(s) {
        var t = message_translations[current_language][s];
        return (t) ? t : s;
    }

    var change_language = function(lang) {
        var xlate = translations[lang];

        var new_value;

        var bound_updater = function() {
            var target = $(this);
            if (target.is('input,textarea')) { // KLUDGE others?
                if (target.val() !== new_value) // KLUDGE necessary?
                    target.val(new_value);
            } else {
                target.html(new_value);
            }
        };

        for (var tag in xlate) {
            new_value = xlate[tag];
            $('.V-sign_in-' + tag).each(bound_updater);
        }
        document.title = xlate.sign_in_title; // KLUDGE just title?

        var tr_names = language_name_matrix[lang];
        for (var tr_code in tr_names) {
            $('.language_' + tr_code).attr('title', tr_names[tr_code]);
        }

        var links = $('<p></p>');
        for (var i = 0; i < languages.length; i++) {
            var tr_lang = languages[i];
            var xlate = translations[tr_lang];
            if (i > 0)
                links.append(' &middot; ');

            var link = $(lang === tr_lang ? '<span></span>' : '<a></a>')
                .html(xlate.language_name)
                .attr({
                    href: '#' + tr_lang,
                    title: language_name_matrix[lang][tr_lang]
                })
                .addClass('language_' + tr_lang)
                .data('language', tr_lang)
                .click(change_language_ev);
            links.append(link);
        }
        $('.language-selector p').replaceWith(links);

        current_language = lang;

        $('.xl8').each(function() {
            var that = $(this);
            var text = that.data('xl8');
            if (typeof(text) == 'string')
                that.html(tr(text));
        });
    };

    var change_language_ev = function(ev) {
        ev.preventDefault();
        change_language($(ev.target).data('language'));
    };

    var post_to_url = function(url, params) {
        var form = $('<form>');
        form.attr({method: 'POST', action: url});
        for (var key in params) {
            var input = $('<input type="hidden">');
            input.attr({name: key, value: params[key]});
            form.append(input);
        }
        form.appendTo(document.body);
        form.submit();
    };

    var error_msg = function(s) {
        $('.error-message').html(tr(s)).data('xl8', s);
        $('.field').addClass('error-field');
    };

    var target_queue = [];

    function process_target_queue() {
        var delta = {};
        for (var i = 0; i < target_queue.length; i++) {
            var target = target_queue[i];
            var val = target.val();
            if (target.data('val') !== val) {
                target.data('val', val);
                delta[target.attr('name')] = val;
            }
        }
        if (!$.isEmptyObject(delta)) {
            $('.error-message').html('').data('xl8', '');
            $('.field').removeClass('error-field');
        }
        target_queue = [];
    }

    function queue_target(ev) {
        var target = $(ev.target);
        if (target.is(':input')) {
            // Defer all of our processing until after all the event's
            // effects have percolated through the system
            if (target_queue.length === 0)
                setTimeout(process_target_queue, 0);
            target_queue.push(target);
        }
        return true;
    }

    // KLUDGE use $.on() for jQuery >= 1.7
    $('body').bind('keydown keyup mousedown mouseup', queue_target);

    $('.sign-in form').submit(function(ev) {
        ev.preventDefault();
        var values = {};
        $(this).find('input').each(function() {
            values[$(this).attr('name')] = $(this).val();
        });
        var ok = false;
        $.ajax({
            url: '/comet/sign_in',
            data: values,
            dataType: 'json',
            success: function(data, status) {
                if (status === 'success' && data.url != null) {
                    ok = true;
                    var copt = {secure: true, path: '/'};
                    $.cookie('authorization_key', data.authorization_key, copt);
                    var url;
                    if (request.query.next !== undefined)
                        url = request.query.next;
                    else
                        url = data.url;
                    post_to_url(url, {
                        session_key: data.session_key,
                        authorization_key: data.authorization_key,
                        language: current_language
                    });
                }
            },
            complete: function(jqXHR, status) {
                if (ok)
                    return;
                if (status === 'success' || status === 'error') {
                    error_msg("Incorrect user name or password");
                } else {
                    error_msg("Connection error");
                }
            }
        });
        return false;
    });

    for (var i = 0; i < request.accept_language.length; i++) {
        var al = request.accept_language[i];
        if (translations[al.lang]) {
            current_language = al.lang;
        } else if (translations[al.base]) {
            current_language = al.base;
        }
    }

    // KLUDGE check hashtag here

    if (!current_language)
        current_language = 'en-US';
    change_language(current_language);

    $('input[name=user_name]').focus();
});
</script>

</head>
<body>
<div class="language-selector">
<p></p>
</div>

<div class="vertical-spacer"></div>

<div class="sign-in">
    <form>
        <fieldset>
            <legend class="V-sign_in-sign_in_title">Sign In - eDAQ Armada</legend>
            <label><span class="V-sign_in-user_name_label">User Name</span>
                <input class="field" type="text" name="user_name" size="24">
            </label>
            <label><span class="V-sign_in-password_label">Password</span>
                <input class="field" type="password" name="password" size="24">
            </label>
            <input type="submit" name="submit" value="Sign In" class="V-sign_in-sign_in_label">
        </fieldset>
        <div class="error-message xl8"></div>
    </form>
</div>

</body></html>
