"use strict";

var app = window.app;
if (typeof(app) === 'undefined')
    app = window.app = {};

app.defaults = {};
app.defaults.tabs = [
    {label: "Summary", target: "summary-tab"},
    {label: "Hardware", target: "hardware-tab"},
    {label: "Channels", target: "channels-tab"},
    {label: "Displays", target: "displays-tab"},
    {label: "Run", target: "run-tab"},
    {label: "Data", target: "data-tab"},
    {label: "Debug", target: "debug-tab"}
];
app.defaults.channel_columns = [
    // category: source, filter, sink, filter/expression, sink/time_history
    {id: "category", name: "Category", field: "category", width: 100},
    {id: "collect", name: "Collect", field: "collect", width: 50,
        cssClass: "cell-collect", profile: "ArmadaCheckbox"
    },
    {id: "select", name: "Select", field: "select", width: 50,
        cssClass: "cell-collect", profile: "ArmadaCheckbox"
    },
    {id: "connector", name: "Connector", field: "connector", width: 250},
    {id: "name", name: "Name", field: "name", width: 250},
    {id: "description", name: "Description", field: "description", width: 250},
    {id: "sample_rate", name: "Sample Rate", field: "sample_rate", width: 100},
    {id: "reading", name: "Reading", field: "reading", width: 120,
        profile: "ArmadaLive", _live_key: "connector"},
    {id: "units", name: "Units", field: "units", width: 80},
    {id: "range_min", name: "Min", field: "range_min", width: 60},
    {id: "range_max", name: "Max", field: "range_max", width: 60},
    {id: "can", name: "CAN", field: "can", width: 80},
    {id: "calibration", name: "Calibration", field: "calibration", width: 180},
    // DIO
    {id: "output_state", name: "Output State", field: "output_state", width: 100},
    {id: "threshold_high", name: "High Threshold", field: "threshold_high", width: 100},
    {id: "threshold_low", name: "Low Threshold", field: "threshold_low", width: 100},
    // cDAQ
    {id: "update_rate", name: "Update Rate", field: "update_rate", width: 100},
    {id: "unit_identify", name: "Unit Identify", field: "unit_identify", width: 100},
    {id: "channel_mode", name: "Channel Mode", field: "channel_mode", width: 100},
    // Computed
    {id: "expression", name: "Expression", field: "expression", width: 150},
    // DataModes(tm)
    {id: "trigger_mode", name: "Trigger Mode", field: "trigger_mode", width: 100}, // Always On, One shot, gate, ...
    {id: "trigger_expression", name: "Trigger Expression",
        field: "trigger_expression", width: 150},
    {id: "input_channels", name: "Input Channels",
        field: "input_channels", width: 250},
    // Summary
    {id: "test_name", name: "Setup Name", field: "test_name", width: 250},
    {id: "test_title", name: "Title", field: "test_title", width: 250},
    {id: "test_author", name: "Author", field: "test_author", width: 250},
    {id: "test_synopsis", name: "Synopsis", field: "test_synopsis", width: 250},
    // QuantumX
    {id: "max_signal_level", name: "Maximum Signal Level", field: "max_signal_level", width: 150},
    {id: "filter_charac", name: "Filter Characteristics", field: "filter_charac", width: 150},
    {id: "filter_freq", name: "Filter Frequency", field: "filter_freq", width: 115},
    {id: "filter_type", name: "Filter Type", field: "filter_type", width: 75},
    {id: "transducer_power", name: "Transducer Power", field: "transducer_power", width: 125},
    {id: "sensor_type", name: "Sensor Type", field: "sensor_type", width: 150},
    {id: "excitation_amplitude", name: "Excitation Amplitude", field: "excitation_amplitude", width: 150},
    {id: "excitation_frequency", name: "Excitation Frequency", field: "excitation_frequency", width: 150},
    {id: "bridge_type", name: "Bridge Type", field: "bridge_type", width: 150},
    {id: "wiring", name: "Bridge Wiring", field: "wiring", width: 150},
    {id: "bridge_resistance", name: "Bridge Resistance", field: "bridge_resistance", width: 150},
    {id: "drift_compensation_mode", name: "Drift Compensation Mode", field: "drift_compensation_mode", width: 150},
    {id: "drift_repetition_time", name: "Drift Compensation Repetition Rate", field: "drift_repetition_time", width: 150},
    {id: "scaling_type", name: "Scaling Mode", field: "scaling_type", width: 100},
    {id: "x1", name: "X1 (Linear Table)", field: "x1", width: 100},
    {id: "y1", name: "Y1 (Linear Table)", field: "y1", width: 100},
    {id: "x2", name: "X2 (Linear Table)", field: "x2", width: 100},
    {id: "y2", name: "Y2 (Linear Table)", field: "y2", width: 100},
    {id: "slope", name: "Slope (Gain)", field: "slope", width: 100},
    {id: "offset", name: "Offset (Gain)", field: "offset", width: 100},
    {id: "kfactor", name: "Bridge K Factor (Straingage)", field: "kfactor", width: 100},
    {id: "bridge_factor", name: "Bridge Factor (Straingage)", field: "bridge_factor", width: 100},
    {id: "electrical_zero", name: "Zero (ZeroSpan)", field: "electrical_zero", width: 100},
    {id: "electrical_span", name: "Electrical Span (ZeroSpan)", field: "electrical_span", width: 100},
    {id: "physical_span", name: "Physical Span (ZeroSpan)", field: "physical_span", width: 100},
    {id: "zo_inhibit", name: "Zero Offset Inhibit", field: "zo_inhibit", width: 100},
    {id: "zo_offset", name: "Zero Offset", field: "zo_offset", width: 100},
    {id: "zo_target", name: "Zero Target", field: "zo_target", width: 100},
    // Data
    {id: "data_file", name: "Data File", field: "data_file", width: 300},
    {id: "size", name: "Size", field: "size", width: 50},
    {id: "data_date", name: "Date", field: "data_date", width: 100},
    {id: "action", name: "Action", field: "action", width: 100},
    // Logs
    {id: "log_date", name: "Date", field: "log_date", width: 200},
    {id: "level", name: "Level", field: "level", width: 100},
    {id: "message", name: "Message", field: "message", width: 600}
];

app.defaults.column_index = {};
var idx;
for (idx = 0; idx < app.defaults.channel_columns.length; ++idx) {
    var col = app.defaults.channel_columns[idx];
    app.defaults.column_index[col.id] = col;
}

app.defaults.channel_column_sets = [
    {label: "Basic", columns: ["collect", "select", "connector", "name", "description", "sample_rate", "reading", "units"]},
    {label: "Calibration", columns: ["connector", "reading", "calibration", "range_min", "range_max"]},
    {label: "Computed", columns: ["collect", "select", "name", "description", "sample_rate", "expression", "units"]},
    {label: "DataModes", columns: ["name", "trigger_mode", "trigger_expression", "input_channels"]},
    {label: "DIO", columns: [
        "connector",
        "reading",
        //"output_state",
        "threshold_high",
        "threshold_low"
    ]},
    {label: "CAN", columns: ["connector", "can"]},
    {label: "QuantumX", columns: [
        "collect",
        "select",
        "connector",
        "name",
        "sensor_type",
        "sample_rate",
        "max_signal_level",
        "transducer_power",
        "filter_type",
        "filter_charac",
        "filter_freq",
        "zo_inhibit",
        "zo_offset",
        "zo_target",
        "scaling_type",
        "x1",
        "y1",
        "x2",
        "y2",
        "slope",
        "offset",
        "electrical_zero",
        "electrical_span",
        "physical_span",
        "reading",
        "units"
    ]},
    {label: "MX1615", columns: [
        "collect",
        "connector",
        "name",
        "sensor_type",
        "sample_rate",
        "max_signal_level",
        "filter_type",
        "filter_charac",
        "filter_freq",
        "zo_inhibit",
        "zo_offset",
        "zo_target",
        "scaling_type",
        "x1",
        "y1",
        "x2",
        "y2",
        "slope",
        "offset",
        "electrical_zero",
        "electrical_span",
        "physical_span",
        "kfactor",
        "bridge_factor",
        "excitation_amplitude",
        "excitation_frequency",
        "bridge_type",
        "wiring",
        "bridge_resistance",
        "drift_compensation_mode",
        "drift_repetition_time",
        "reading",
        "units"
    ]},
    {label: "Reading", columns: ["name", "reading"]},
    {label: "Summary", columns: ["test_name", "test_title", "test_author", "test_synopsis"]},
    {label: "All", columns: null}
];
